<?php
/*
 * COPYRIGHT BY JONATHAN SIEBERN
 * 
 * DO NOT DISTRIBUTE AND UPLOAD ANYWHERE ELSE THAN
 * THE osTicket FORUMS
 * 
 * DEVELOPERS: FEEL FREE TO USE THIS FILE AS AN INSPIRATION
 * AND EVEN COPY CODE BUT PLEASE MENTION ME IN THE COPYRIGHT
 * 
 */

session_start();
error_reporting(E_ALL);

define('INDEX_FILE','_install_smtp_mod.php');
define('ABSOLUTE',dirname(__FILE__));
define('FILE_CONFIG',ABSOLUTE.'/include/ost-config.php');
define('FILE_MAIN_INC',ABSOLUTE.'/main.inc.php');
define('FILE_CLASS_EMAIL',ABSOLUTE.'/include/class.email.php');
define('FILE_CLASS_MAILER',ABSOLUTE.'/include/class.mailer.php');
define('FILE_EMAIL_INC',ABSOLUTE.'/include/staff/email.inc.php');
$class_email_php = '<?php'."\n".'/*********************************************************************'."\n".'    class.email.php'."\n\n".'    Peter Rotich <peter@osticket.com>'."\n".'    Copyright (c)  2006-2013 osTicket'."\n".'    http://www.osticket.com'."\n\n".'    Released under the GNU General Public License WITHOUT ANY WARRANTY.'."\n".'    See LICENSE.TXT for details.'."\n\n".'    vim: expandtab sw=4 ts=4 sts=4:'."\n".'**********************************************************************/'."\n\n".'include_once(INCLUDE_DIR.\'class.dept.php\');'."\n".'include_once(INCLUDE_DIR.\'class.mailfetch.php\');'."\n\n".'class Email {'."\n".'    var $id;'."\n".'    var $address;'."\n\n".'    var $dept;'."\n".'    var $ht;'."\n\n".'    function Email($id) {'."\n".'        $this->id=0;'."\n".'        $this->load($id);'."\n".'    }'."\n\n".'    function load($id=0) {'."\n\n".'        if(!$id && !($id=$this->getId()))'."\n".'            return false;'."\n\n".'        $sql=\'SELECT * FROM \'.EMAIL_TABLE.\' WHERE email_id=\'.db_input($id);'."\n".'        if(!($res=db_query($sql)) || !db_num_rows($res))'."\n".'            return false;'."\n\n\n".'        $this->ht=db_fetch_array($res);'."\n".'        $this->id=$this->ht[\'email_id\'];'."\n".'        $this->address=$this->ht[\'name\']?($this->ht[\'name\'].\'<\'.$this->ht[\'email\'].\'>\'):$this->ht[\'email\'];'."\n\n".'        $this->dept = null;'."\n\n".'        return true;'."\n".'    }'."\n\n".'    function reload() {'."\n".'        return $this->load();'."\n".'    }'."\n\n".'    function getId() {'."\n".'        return $this->id;'."\n".'    }'."\n\n".'    function getEmail() {'."\n".'        return $this->ht[\'email\'];'."\n".'    }'."\n\n".'    function getAddress() {'."\n".'        return $this->address;'."\n".'    }'."\n\n".'    function getName() {'."\n".'        return $this->ht[\'name\'];'."\n".'    }'."\n\n".'    function getPriorityId() {'."\n".'        return $this->ht[\'priority_id\'];'."\n".'    }'."\n\n".'    function getDeptId() {'."\n".'        return $this->ht[\'dept_id\'];'."\n".'    }'."\n\n".'    function getDept() {'."\n\n".'        if(!$this->dept && $this->getDeptId())'."\n".'            $this->dept=Dept::lookup($this->getDeptId());'."\n\n".'        return $this->dept;'."\n".'    }'."\n\n".'    function autoRespond() {'."\n".'        return (!$this->ht[\'noautoresp\']);'."\n".'    }'."\n\n".'    function getPasswd() {'."\n".'        return $this->ht[\'userpass\']?Crypto::decrypt($this->ht[\'userpass\'], SECRET_SALT, $this->ht[\'userid\']):\'\';'."\n".'    }'."\n\n".'    function getHashtable() {'."\n".'        return $this->ht;'."\n".'    }'."\n\n".'    function getInfo() {'."\n".'        return $this->getHashtable();'."\n".'    }'."\n\n".'    function getMailAccountInfo() {'."\n\n".'        /*NOTE: Do not change any of the tags - otherwise mail fetching will fail */'."\n".'        $info = array('."\n".'                //Mail server info'."\n".'                \'host\'  => $this->ht[\'mail_host\'],'."\n".'                \'port\'  => $this->ht[\'mail_port\'],'."\n".'                \'protocol\'  => $this->ht[\'mail_protocol\'],'."\n".'                \'encryption\' => $this->ht[\'mail_encryption\'],'."\n".'                \'username\'  => $this->ht[\'userid\'],'."\n".'                \'password\' => Crypto::decrypt($this->ht[\'userpass\'], SECRET_SALT, $this->ht[\'userid\']),'."\n".'                //osTicket specific'."\n".'                \'email_id\'  => $this->getId(), //Required for email routing to work.'."\n".'                \'max_fetch\' => $this->ht[\'mail_fetchmax\'],'."\n".'                \'delete_mail\' => $this->ht[\'mail_delete\'],'."\n".'                \'archive_folder\' => $this->ht[\'mail_archivefolder\']'."\n".'                );'."\n\n".'        return $info;'."\n".'    }'."\n\n".'    function isSMTPEnabled() {'."\n\n".'        return ('."\n".'                $this->ht[\'smtp_active\']'."\n".'                    && ($info=$this->getSMTPInfo())'."\n".'                    && (!$info[\'auth\'] || $info[\'password\'])'."\n".'                );'."\n".'    }'."\n\n".'    function allowSpoofing() {'."\n".'        return ($this->ht[\'smtp_spoofing\']);'."\n".'    }'."\n\n".'    function getSMTPInfo() {'."\n\n".'        $info = array ('."\n".'                \'user\' => $this->ht[\'smtp_user\'],'."\n".'                \'pass\' => $this->ht[\'smtp_pass\'],'."\n".'                \'host\' => $this->ht[\'smtp_host\'],'."\n".'                \'port\' => $this->ht[\'smtp_port\'],'."\n".'                \'auth\' => (bool) $this->ht[\'smtp_auth\'],'."\n".'                \'username\' => $this->ht[\'smtp_user\'],'."\n".'                \'password\' => $this->ht[\'smtp_pass\']'."\n".'                );'."\n\n".'        return $info;'."\n".'    }'."\n\n".'    function send($to, $subject, $message, $attachments=null, $options=null) {'."\n\n".'        $mailer = new Mailer($this);'."\n".'        if($attachments)'."\n".'            $mailer->addAttachments($attachments);'."\n\n".'        return $mailer->send($to, $subject, $message, $options);'."\n".'    }'."\n\n".'    function sendAutoReply($to, $subject, $message, $attachments=null, $options=array()) {'."\n".'        $options+= array(\'autoreply\' => true);'."\n".'        return $this->send($to, $subject, $message, $attachments, $options);'."\n".'    }'."\n\n".'    function sendAlert($to, $subject, $message, $attachments=null, $options=array()) {'."\n".'        $options+= array(\'bulk\' => true);'."\n".'        return $this->send($to, $subject, $message, $attachments, $options);'."\n".'    }'."\n\n".'    function update($vars,&$errors) {'."\n".'        $vars=$vars;'."\n".'        $vars[\'cpasswd\']=$this->getPasswd(); //Current decrypted password.'."\n\n".'        if(!$this->save($this->getId(), $vars, $errors))'."\n".'            return false;'."\n\n".'        $this->reload();'."\n\n".'        return true;'."\n".'    }'."\n\n\n".'   function delete() {'."\n".'        global $cfg;'."\n".'        //Make sure we are not trying to delete default emails.'."\n".'        if(!$cfg || $this->getId()==$cfg->getDefaultEmailId() || $this->getId()==$cfg->getAlertEmailId()) //double...double check.'."\n".'            return 0;'."\n\n".'        $sql=\'DELETE FROM \'.EMAIL_TABLE.\' WHERE email_id=\'.db_input($this->getId()).\' LIMIT 1\';'."\n".'        if(db_query($sql) && ($num=db_affected_rows())) {'."\n".'            $sql=\'UPDATE \'.DEPT_TABLE.\' SET autoresp_email_id=0 \'.'."\n".'                 \',email_id=\'.db_input($cfg->getDefaultEmailId()).'."\n".'                 \' WHERE email_id=\'.db_input($this->getId());'."\n".'            db_query($sql);'."\n".'        }'."\n\n".'        return $num;'."\n".'    }'."\n\n\n".'    /******* Static functions ************/'."\n\n".'   function getIdByEmail($email) {'."\n\n".'        $sql=\'SELECT email_id FROM \'.EMAIL_TABLE.\' WHERE email=\'.db_input($email);'."\n".'        if(($res=db_query($sql)) && db_num_rows($res))'."\n".'            list($id)=db_fetch_row($res);'."\n\n".'        return $id;'."\n".'    }'."\n\n".'    function lookup($var) {'."\n".'        $id=is_numeric($var)?$var:Email::getIdByEmail($var);'."\n".'        return ($id && is_numeric($id) && ($email=new Email($id)) && $email->getId())?$email:null;'."\n".'    }'."\n\n".'    function create($vars,&$errors) {'."\n".'        return Email::save(0,$vars,$errors);'."\n".'    }'."\n\n\n".'    function save($id,$vars,&$errors) {'."\n".'        global $cfg;'."\n".'        //very basic checks'."\n\n".'        $vars[\'name\']=Format::striptags(trim($vars[\'name\']));'."\n".'        $vars[\'email\']=trim($vars[\'email\']);'."\n\n".'        if($id && $id!=$vars[\'id\'])'."\n".'            $errors[\'err\']=\'Internal error. Get technical help.\';'."\n\n".'        if(!$vars[\'email\'] || !Validator::is_email($vars[\'email\'])) {'."\n".'            $errors[\'email\']=\'Valid email required\';'."\n".'        }elseif(($eid=Email::getIdByEmail($vars[\'email\'])) && $eid!=$id) {'."\n".'            $errors[\'email\']=\'Email already exists\';'."\n".'        }elseif($cfg && !strcasecmp($cfg->getAdminEmail(), $vars[\'email\'])) {'."\n".'            $errors[\'email\']=\'Email already used as admin email!\';'."\n".'        }elseif(Staff::getIdByEmail($vars[\'email\'])) { //make sure the email doesn\'t belong to any of the staff'."\n".'            $errors[\'email\']=\'Email in use by a staff member\';'."\n".'        }'."\n\n".'        if(!$vars[\'name\'])'."\n".'            $errors[\'name\']=\'Email name required\';'."\n\n".'        if($vars[\'mail_active\'] || ($vars[\'smtp_active\'] && $vars[\'smtp_auth\'])) {'."\n".'            if(!$vars[\'userid\'])'."\n".'                $errors[\'userid\']=\'Username missing\';'."\n\n".'            if(!$id && !$vars[\'passwd\'])'."\n".'                $errors[\'passwd\']=\'Password required\';'."\n".'            elseif($vars[\'passwd\']'."\n".'                    && $vars[\'userid\']'."\n".'                    && !Crypto::encrypt($vars[\'passwd\'], SECRET_SALT, $vars[\'userid\'])'."\n".'                    )'."\n".'                $errors[\'passwd\'] = \'Unable to encrypt password - get technical support\';'."\n".'        }'."\n\n".'        if($vars[\'mail_active\']) {'."\n".'            //Check pop/imapinfo only when enabled.'."\n".'            if(!function_exists(\'imap_open\'))'."\n".'                $errors[\'mail_active\']= \'IMAP doesn\\\'t exist. PHP must be compiled with IMAP enabled.\';'."\n".'            if(!$vars[\'mail_host\'])'."\n".'                $errors[\'mail_host\']=\'Host name required\';'."\n".'            if(!$vars[\'mail_port\'])'."\n".'                $errors[\'mail_port\']=\'Port required\';'."\n".'            if(!$vars[\'mail_protocol\'])'."\n".'                $errors[\'mail_protocol\']=\'Select protocol\';'."\n".'            if(!$vars[\'mail_fetchfreq\'] || !is_numeric($vars[\'mail_fetchfreq\']))'."\n".'                $errors[\'mail_fetchfreq\']=\'Fetch interval required\';'."\n".'            if(!$vars[\'mail_fetchmax\'] || !is_numeric($vars[\'mail_fetchmax\']))'."\n".'                $errors[\'mail_fetchmax\']=\'Maximum emails required\';'."\n".'            if(!$vars[\'dept_id\'] || !is_numeric($vars[\'dept_id\']))'."\n".'                $errors[\'dept_id\']=\'You must select a Dept.\';'."\n".'            if(!$vars[\'priority_id\'])'."\n".'                $errors[\'priority_id\']=\'You must select a priority\';'."\n\n".'            if(!isset($vars[\'postfetch\']))'."\n".'                $errors[\'postfetch\']=\'Indicate what to do with fetched emails\';'."\n".'            elseif(!strcasecmp($vars[\'postfetch\'],\'archive\') && !$vars[\'mail_archivefolder\'] )'."\n".'                $errors[\'postfetch\']=\'Valid folder required\';'."\n".'        }'."\n\n".'        if($vars[\'smtp_active\']) {'."\n".'            if(!$vars[\'smtp_host\'])'."\n".'                $errors[\'smtp_host\']=\'Host name required\';'."\n".'            if(!$vars[\'smtp_port\'])'."\n".'                $errors[\'smtp_port\']=\'Port required\';'."\n".'        }'."\n\n".'        //abort on errors'."\n".'        if($errors) return false;'."\n\n".'        if(!$errors && ($vars[\'mail_host\'] && $vars[\'userid\'])) {'."\n".'            $sql=\'SELECT email_id FROM \'.EMAIL_TABLE'."\n".'                .\' WHERE mail_host=\'.db_input($vars[\'mail_host\']).\' AND userid=\'.db_input($vars[\'userid\']);'."\n".'            if($id)'."\n".'                $sql.=\' AND email_id!=\'.db_input($id);'."\n\n".'            if(db_num_rows(db_query($sql)))'."\n".'                $errors[\'userid\']=$errors[\'host\']=\'Host/userid combination already in use.\';'."\n".'        }'."\n\n".'        $passwd=$vars[\'passwd\']?$vars[\'passwd\']:$vars[\'cpasswd\'];'."\n".'        if(!$errors && $vars[\'mail_active\']) {'."\n".'            //note: password is unencrypted at this point...MailFetcher expect plain text.'."\n".'            $fetcher = new MailFetcher('."\n".'                    array('."\n".'                        \'host\'  => $vars[\'mail_host\'],'."\n".'                        \'port\'  => $vars[\'mail_port\'],'."\n".'                        \'username\'  => $vars[\'userid\'],'."\n".'                        \'password\'  => $passwd,'."\n".'                        \'protocol\'  => $vars[\'mail_protocol\'],'."\n".'                        \'encryption\' => $vars[\'mail_encryption\'])'."\n".'                    );'."\n".'            if(!$fetcher->connect()) {'."\n".'                $errors[\'err\']=\'Invalid login. Check \'.Format::htmlchars($vars[\'mail_protocol\']).\' settings\';'."\n".'                $errors[\'mail\']=\'<br>\'.$fetcher->getLastError();'."\n".'            }elseif($vars[\'mail_archivefolder\'] && !$fetcher->checkMailbox($vars[\'mail_archivefolder\'],true)) {'."\n".'                 $errors[\'postfetch\']=\'Invalid or unknown mail folder! >> \'.$fetcher->getLastError().\'\';'."\n".'                 if(!$errors[\'mail\'])'."\n".'                     $errors[\'mail\']=\'Invalid or unknown archive folder!\';'."\n".'            }'."\n".'        }'."\n\n".'        if(!$errors && $vars[\'smtp_active\']) { //Check SMTP login only.'."\n".'            require_once \'Mail.php\'; // PEAR Mail package'."\n".'            $smtp = mail::factory(\'smtp\','."\n".'                    array (\'host\' => $vars[\'smtp_host\'],'."\n".'                           \'port\' => $vars[\'smtp_port\'],'."\n".'                           \'auth\' => (bool) $vars[\'smtp_auth\'],'."\n".'                           \'username\' =>$vars[\'smtp_user\'],'."\n".'                           \'password\' =>$vars[\'smtp_pass\'],'."\n".'                           \'timeout\'  =>20,'."\n".'                           \'debug\' => false,'."\n".'                           ));'."\n".'            $mail = $smtp->connect();'."\n".'            if(PEAR::isError($mail)) {'."\n".'                $errors[\'err\']=\'Unable to log in. Check SMTP settings.\';'."\n".'                $errors[\'smtp\']=\'<br>\'.$mail->getMessage();'."\n".'            }else{'."\n".'                $smtp->disconnect(); //Thank you, sir!'."\n".'            }'."\n".'        }'."\n\n".'        if($errors) return false;'."\n\n".'        //Default to default priority and dept..'."\n".'        if(!$vars[\'priority_id\'] && $cfg)'."\n".'            $vars[\'priority_id\']=$cfg->getDefaultPriorityId();'."\n".'        if(!$vars[\'dept_id\'] && $cfg)'."\n".'            $vars[\'dept_id\']=$cfg->getDefaultDeptId();'."\n\n".'        $sql=\'updated=NOW(),mail_errors=0, mail_lastfetch=NULL\'.'."\n".'             \',email=\'.db_input($vars[\'email\']).'."\n".'             \',name=\'.db_input(Format::striptags($vars[\'name\'])).'."\n".'             \',dept_id=\'.db_input($vars[\'dept_id\']).'."\n".'             \',priority_id=\'.db_input($vars[\'priority_id\']).'."\n".'             \',noautoresp=\'.db_input(isset($vars[\'noautoresp\'])?1:0).'."\n".'             \',userid=\'.db_input($vars[\'userid\']).'."\n".'             \',mail_active=\'.db_input($vars[\'mail_active\']).'."\n".'             \',mail_host=\'.db_input($vars[\'mail_host\']).'."\n".'             \',mail_protocol=\'.db_input($vars[\'mail_protocol\']?$vars[\'mail_protocol\']:\'POP\').'."\n".'             \',mail_encryption=\'.db_input($vars[\'mail_encryption\']).'."\n".'             \',mail_port=\'.db_input($vars[\'mail_port\']?$vars[\'mail_port\']:0).'."\n".'             \',mail_fetchfreq=\'.db_input($vars[\'mail_fetchfreq\']?$vars[\'mail_fetchfreq\']:0).'."\n".'             \',mail_fetchmax=\'.db_input($vars[\'mail_fetchmax\']?$vars[\'mail_fetchmax\']:0).'."\n".'             \',smtp_user=\'.db_input($vars[\'smtp_user\']).'."\n".'             \',smtp_pass=\'.db_input($vars[\'smtp_pass\']).'."\n".'             \',smtp_active=\'.db_input($vars[\'smtp_active\']).'."\n".'             \',smtp_host=\'.db_input($vars[\'smtp_host\']).'."\n".'             \',smtp_port=\'.db_input($vars[\'smtp_port\']?$vars[\'smtp_port\']:0).'."\n".'             \',smtp_auth=\'.db_input($vars[\'smtp_auth\']).'."\n".'             \',smtp_spoofing=\'.db_input(isset($vars[\'smtp_spoofing\'])?1:0).'."\n".'             \',notes=\'.db_input($vars[\'notes\']);'."\n\n".'        //Post fetch email handling...'."\n".'        if($vars[\'postfetch\'] && !strcasecmp($vars[\'postfetch\'],\'delete\'))'."\n".'            $sql.=\',mail_delete=1,mail_archivefolder=NULL\';'."\n".'        elseif($vars[\'postfetch\'] && !strcasecmp($vars[\'postfetch\'],\'archive\') && $vars[\'mail_archivefolder\'])'."\n".'            $sql.=\',mail_delete=0,mail_archivefolder=\'.db_input($vars[\'mail_archivefolder\']);'."\n".'        else'."\n".'            $sql.=\',mail_delete=0,mail_archivefolder=NULL\';'."\n\n".'        if($vars[\'passwd\']) //New password - encrypt.'."\n".'            $sql.=\',userpass=\'.db_input(Crypto::encrypt($vars[\'passwd\'],SECRET_SALT, $vars[\'userid\']));'."\n\n".'        if($id) { //update'."\n".'            $sql=\'UPDATE \'.EMAIL_TABLE.\' SET \'.$sql.\' WHERE email_id=\'.db_input($id);'."\n".'            if(db_query($sql) && db_affected_rows())'."\n".'                return true;'."\n\n".'            $errors[\'err\']=\'Unable to update email. Internal error occurred\';'."\n".'        }else {'."\n".'            $sql=\'INSERT INTO \'.EMAIL_TABLE.\' SET \'.$sql.\',created=NOW()\';'."\n".'            if(db_query($sql) && ($id=db_insert_id()))'."\n".'                return $id;'."\n\n".'            $errors[\'err\']=\'Unable to add email. Internal error\';'."\n".'        }'."\n\n".'        return false;'."\n".'    }'."\n".'}'."\n".'?>';
$class_mailer_php = '<?php'."\n".'/*********************************************************************'."\n".'    class.mailer.php'."\n\n".'    osTicket mailer'."\n\n".'    It\'s mainly PEAR MAIL wrapper for now (more improvements planned).'."\n\n".'    Peter Rotich <peter@osticket.com>'."\n".'    Copyright (c)  2006-2013 osTicket'."\n".'    http://www.osticket.com'."\n\n".'    Released under the GNU General Public License WITHOUT ANY WARRANTY.'."\n".'    See LICENSE.TXT for details.'."\n\n".'    vim: expandtab sw=4 ts=4 sts=4:'."\n".'**********************************************************************/'."\n\n".'include_once(INCLUDE_DIR.\'class.email.php\');'."\n\n".'class Mailer {'."\n\n".'    var $email;'."\n\n".'    var $ht = array();'."\n".'    var $attachments = array();'."\n\n".'    var $smtp = array();'."\n".'    var $eol="\\n";'."\n\n".'    function Mailer($email=null, $options=null) {'."\n".'        global $cfg;'."\n\n".'        if(is_object($email) && $email->isSMTPEnabled() && ($info=$email->getSMTPInfo())) { //is SMTP enabled for the current email?'."\n".'            $this->smtp = $info;'."\n".'        } elseif($cfg && ($e=$cfg->getDefaultSMTPEmail()) && $e->isSMTPEnabled()) { //What about global SMTP setting?'."\n".'            $this->smtp = $e->getSMTPInfo();'."\n".'            if(!$e->allowSpoofing() || !$email)'."\n".'                $email = $e;'."\n".'        } elseif(!$email && $cfg && ($e=$cfg->getDefaultEmail())) {'."\n".'            if($e->isSMTPEnabled() && ($info=$email->getSMTPInfo()))'."\n".'                $this->smtp = $info;'."\n".'            $email = $e;'."\n".'        }'."\n\n".'        $this->email = $email;'."\n".'        $this->attachments = array();'."\n".'    }'."\n\n".'    function getEOL() {'."\n".'        return $this->eol;'."\n".'    }'."\n\n".'    function getEmail() {'."\n".'        return $this->email;'."\n".'    }'."\n\n".'    function getSMTPInfo() {'."\n".'        return $this->smtp;'."\n".'    }'."\n".'    /* FROM Address */'."\n".'    function setFromAddress($from) {'."\n".'        $this->ht[\'from\'] = $from;'."\n".'    }'."\n\n".'    function getFromAddress() {'."\n\n".'        if(!$this->ht[\'from\'] && ($email=$this->getEmail()))'."\n".'            $this->ht[\'from\'] =sprintf(\'"%s" <%s>\', ($email->getName()?$email->getName():$email->getEmail()), $email->getEmail());'."\n\n".'        return $this->ht[\'from\'];'."\n".'    }'."\n\n".'    /* attachments */'."\n".'    function getAttachments() {'."\n".'        return $this->attachments;'."\n".'    }'."\n\n".'    function addAttachment($attachment) {'."\n".'        $this->attachments[] = $attachment;'."\n".'    }'."\n\n".'    function addAttachments($attachments) {'."\n".'        $this->attachments = array_merge($this->attachments, $attachments);'."\n".'    }'."\n\n".'    function send($to, $subject, $message, $options=null) {'."\n".'        global $ost;'."\n\n".'        //Get the goodies'."\n".'        require_once (PEAR_DIR.\'Mail.php\'); // PEAR Mail package'."\n".'        require_once (PEAR_DIR.\'Mail/mime.php\'); // PEAR Mail_Mime packge'."\n\n".'        //do some cleanup'."\n".'        $to = preg_replace("/(\\r\\n|\\r|\\n)/s",\'\', trim($to));'."\n".'        $subject = preg_replace("/(\\r\\n|\\r|\\n)/s",\'\', trim($subject));'."\n".'        //We\'re decoding html entities here becasuse we only support plain text for now - html support comming.'."\n".'        $body = Format::htmldecode(preg_replace("/(\\r\\n|\\r)/s", "\\n", trim($message)));'."\n\n".'        /* Message ID - generated for each outgoing email */'."\n".'        $messageId = sprintf(\'<%s%d-%s>\', Misc::randCode(6), time(),'."\n".'                ($this->getEmail()?$this->getEmail()->getEmail():\'@osTicketMailer\'));'."\n\n".'        $headers = array ('."\n".'                \'From\' => $this->getFromAddress(),'."\n".'                \'To\' => $to,'."\n".'                \'Subject\' => $subject,'."\n".'                \'Date\'=> date(\'D, d M Y H:i:s O\'),'."\n".'                \'Message-ID\' => $messageId,'."\n".'                \'X-Mailer\' =>\'osTicket Mailer\''."\n".'               );'."\n\n".'        //Set bulk/auto-response headers.'."\n".'        if($options && ($options[\'autoreply\'] or $options[\'bulk\'])) {'."\n".'            $headers+= array('."\n".'                    \'X-Autoreply\' => \'yes\','."\n".'                    \'X-Auto-Response-Suppress\' => \'ALL, AutoReply\','."\n".'                    \'Auto-Submitted\' => \'auto-replied\');'."\n\n".'            if($options[\'bulk\'])'."\n".'                $headers+= array(\'Precedence\' => \'bulk\');'."\n".'            else'."\n".'                $headers+= array(\'Precedence\' => \'auto_reply\');'."\n".'        }'."\n\n".'        if ($options) {'."\n".'            if (isset($options[\'inreplyto\']) && $options[\'inreplyto\'])'."\n".'                $headers += array(\'In-Reply-To\' => $options[\'inreplyto\']);'."\n".'            if (isset($options[\'references\']) && $options[\'references\']) {'."\n".'                if (is_array($options[\'references\']))'."\n".'                    $headers += array(\'References\' =>'."\n".'                        implode(\' \', $options[\'references\']));'."\n".'                else'."\n".'                    $headers += array(\'References\' => $options[\'references\']);'."\n".'            }'."\n".'        }'."\n\n".'        $mime = new Mail_mime();'."\n".'        $mime->setTXTBody($body);'."\n".'        //XXX: Attachments'."\n".'        if(($attachments=$this->getAttachments())) {'."\n".'            foreach($attachments as $attachment) {'."\n".'                if($attachment[\'file_id\'] && ($file=AttachmentFile::lookup($attachment[\'file_id\'])))'."\n".'                    $mime->addAttachment($file->getData(),$file->getType(), $file->getName(),false);'."\n".'                elseif($attachment[\'file\'] &&  file_exists($attachment[\'file\']) && is_readable($attachment[\'file\']))'."\n".'                    $mime->addAttachment($attachment[\'file\'],$attachment[\'type\'],$attachment[\'name\']);'."\n".'            }'."\n".'        }'."\n\n".'        //Desired encodings...'."\n".'        $encodings=array('."\n".'                \'head_encoding\' => \'quoted-printable\','."\n".'                \'text_encoding\' => \'base64\','."\n".'                \'html_encoding\' => \'base64\','."\n".'                \'html_charset\'  => \'utf-8\','."\n".'                \'text_charset\'  => \'utf-8\','."\n".'                \'head_charset\'  => \'utf-8\''."\n".'                );'."\n".'        //encode the body'."\n".'        $body = $mime->get($encodings);'."\n".'        //encode the headers.'."\n".'        $headers = $mime->headers($headers, true);'."\n".'        if(($smtp=$this->getSMTPInfo())) { //Send via SMTP'."\n".'            $mail = mail::factory(\'smtp\','."\n".'                    array (\'host\' => $smtp[\'host\'],'."\n".'                           \'port\' => $smtp[\'port\'],'."\n".'                           \'auth\' => $smtp[\'auth\'],'."\n".'                           \'username\' => $smtp[\'username\'],'."\n".'                           \'password\' => $smtp[\'password\'],'."\n".'                           \'timeout\'  => 20,'."\n".'                           \'debug\' => false,'."\n".'                           ));'."\n\n".'            $result = $mail->send($to, $headers, $body);'."\n".'            if(!PEAR::isError($result))'."\n".'                return $messageId;'."\n\n".'            $alert=sprintf("Unable to email via SMTP:%s:%d [%s]\\n\\n%s\\n",'."\n".'                    $smtp[\'host\'], $smtp[\'port\'], $smtp[\'username\'], $result->getMessage());'."\n".'            $this->logError($alert);'."\n".'        }'."\n\n".'        //No SMTP or it failed....use php\'s native mail function.'."\n".'        $mail = mail::factory(\'mail\');'."\n".'        return PEAR::isError($mail->send($to, $headers, $body))?false:$messageId;'."\n\n".'    }'."\n\n".'    function logError($error) {'."\n".'        global $ost;'."\n".'        //NOTE: Admin alert override - don\'t email when having email trouble!'."\n".'        $ost->logError(\'Mailer Error\', $error, false);'."\n".'    }'."\n\n".'    /******* Static functions ************/'."\n\n".'    //Emails using native php mail function - if DB connection doesn\'t exist.'."\n".'    //Don\'t use this function if you can help it.'."\n".'    function sendmail($to, $subject, $message, $from) {'."\n".'        $mailer = new Mailer();'."\n".'        $mailer->setFromAddress($from);'."\n".'        return $mailer->send($to, $subject, $message);'."\n".'    }'."\n".'}'."\n".'?>';
$email_inc_php = '<?php'."\n".'if(!defined(\'OSTADMININC\') || !$thisstaff || !$thisstaff->isAdmin()) die(\'Access Denied\');'."\n".'$info=array();'."\n".'$qstr=\'\';'."\n".'if($email && $_REQUEST[\'a\']!=\'add\'){'."\n".'    $title=\'Update Email\';'."\n".'    $action=\'update\';'."\n".'    $submit_text=\'Save Changes\';'."\n".'    $info=$email->getInfo();'."\n".'    $info[\'id\']=$email->getId();'."\n".'    if($info[\'mail_delete\'])'."\n".'        $info[\'postfetch\']=\'delete\';'."\n".'    elseif($info[\'mail_archivefolder\'])'."\n".'        $info[\'postfetch\']=\'archive\';'."\n".'    else'."\n".'        $info[\'postfetch\']=\'\'; //nothing.'."\n".'    if($info[\'userpass\'])'."\n".'        $passwdtxt=\'To change password enter new password above.\';'."\n\n".'    $qstr.=\'&id=\'.$email->getId();'."\n".'}else {'."\n".'    $title=\'Add New Email\';'."\n".'    $action=\'create\';'."\n".'    $submit_text=\'Submit\';'."\n".'    $info[\'ispublic\']=isset($info[\'ispublic\'])?$info[\'ispublic\']:1;'."\n".'    $info[\'ticket_auto_response\']=isset($info[\'ticket_auto_response\'])?$info[\'ticket_auto_response\']:1;'."\n".'    $info[\'message_auto_response\']=isset($info[\'message_auto_response\'])?$info[\'message_auto_response\']:1;'."\n".'    $qstr.=\'&a=\'.$_REQUEST[\'a\'];'."\n".'}'."\n".'$info=Format::htmlchars(($errors && $_POST)?$_POST:$info);'."\n".'?>'."\n".'<h2>Email Address</h2>'."\n".'<form action="emails.php?<?php echo $qstr; ?>" method="post" id="save">'."\n".'<?php csrf_token(); ?>'."\n".'<input type="hidden" name="do" value="<?php echo $action; ?>">'."\n".'<input type="hidden" name="a" value="<?php echo Format::htmlchars($_REQUEST[\'a\']); ?>">'."\n".'<input type="hidden" name="id" value="<?php echo $info[\'id\']; ?>">'."\n".'<table class="form_table" width="940" border="0" cellspacing="0" cellpadding="2">'."\n".'<thead>'."\n".'<tr>'."\n".'<th colspan="2">'."\n".'<h4><?php echo $title; ?></h4>'."\n".'<em><strong>Email Information &amp; Settings</strong></em>'."\n".'</th>'."\n".'</tr>'."\n".'</thead>'."\n".'<tbody>'."\n".'<tr>'."\n".'<td width="180" class="required">'."\n".'Email Address'."\n".'</td>'."\n".'<td>'."\n".'<input type="text" size="35" name="email" value="<?php echo $info[\'email\']; ?>">'."\n".'&nbsp;<span class="error">*&nbsp;<?php echo $errors[\'email\']; ?></span>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180" class="required">'."\n".'Email Name'."\n".'</td>'."\n".'<td>'."\n".'<input type="text" size="35" name="name" value="<?php echo $info[\'name\']; ?>">'."\n".'&nbsp;<span class="error">*&nbsp;<?php echo $errors[\'name\']; ?>&nbsp;</span>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180">'."\n".'New Ticket Priority'."\n".'</td>'."\n".'<td>'."\n".'<select name="priority_id">'."\n".'<option value="">&mdash; Select Priority &mdash;</option>'."\n".'<?php'."\n".'                    $sql=\'SELECT priority_id,priority_desc FROM \'.PRIORITY_TABLE.\' pri ORDER by priority_urgency DESC\';'."\n".'                    if(($res=db_query($sql)) && db_num_rows($res)){'."\n".'                        while(list($id,$name)=db_fetch_row($res)){'."\n".'                            $selected=($info[\'priority_id\'] && $id==$info[\'priority_id\'])?\'selected="selected"\':\'\';'."\n".'                            echo sprintf(\'<option value="%d" %s>%s</option>\',$id,$selected,$name);'."\n".'                        }'."\n".'                    }'."\n".'                    ?>'."\n".'</select>'."\n".'&nbsp;<span class="error"><?php echo $errors[\'priority_id\']; ?></span>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180">'."\n".'New Ticket Dept.'."\n".'</td>'."\n".'<td>'."\n".'<select name="dept_id">'."\n".'<option value="">&mdash; Select Department &mdash;</option>'."\n".'<?php'."\n".'                    $sql=\'SELECT dept_id,dept_name FROM \'.DEPT_TABLE.\' dept ORDER by dept_name\';'."\n".'                    if(($res=db_query($sql)) && db_num_rows($res)){'."\n".'                        while(list($id,$name)=db_fetch_row($res)){'."\n".'                            $selected=($info[\'dept_id\'] && $id==$info[\'dept_id\'])?\'selected="selected"\':\'\';'."\n".'                            echo sprintf(\'<option value="%d" %s>%s</option>\',$id,$selected,$name);'."\n".'                        }'."\n".'                    }'."\n".'                    ?>'."\n".'</select>'."\n".'&nbsp;<span class="error"><?php echo $errors[\'dept_id\']; ?></span>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180">'."\n".'Auto-response'."\n".'</td>'."\n".'<td>'."\n".'<input type="checkbox" name="noautoresp" value="1" <?php echo $info[\'noautoresp\']?\'checked="checked"\':\'\'; ?>>'."\n".'<strong>Disable</strong> new ticket auto-response for this'."\n".'email. Override global and dept. settings.'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<th colspan="2">'."\n".'<em><strong>Login Information:</strong>: Optional BUT required when IMAP/POP or SMTP (with auth.) are enabled.</em>'."\n".'</th>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180">'."\n".'Username'."\n".'</td>'."\n".'<td>'."\n".'<input type="text" size="35" name="userid" value="<?php echo $info[\'userid\']; ?>">'."\n".'&nbsp;<span class="error">&nbsp;<?php echo $errors[\'userid\']; ?>&nbsp;</span>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td width="180">'."\n".'Password'."\n".'</td>'."\n".'<td>'."\n".'<input type="password" size="35" name="passwd" value="<?php echo $info[\'passwd\']; ?>">'."\n".'&nbsp;<span class="error">&nbsp;<?php echo $errors[\'passwd\']; ?>&nbsp;</span>'."\n".'<br><em><?php echo $passwdtxt; ?></em>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<th colspan="2">'."\n".'<em><strong>Mail Account</strong>: Optional setting for fetching incoming emails. Mail fetching must be enabled with autocron active or external cron setup. &nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail\']; ?></font></em>'."\n".'</th>'."\n".'</tr>'."\n".'<tr><td>Status</td>'."\n".'<td>'."\n".'<label><input type="radio" name="mail_active" value="1" <?php echo $info[\'mail_active\']?\'checked="checked"\':\'\'; ?> /><strong>Enable</strong></label>'."\n".'&nbsp;&nbsp;'."\n".'<label><input type="radio" name="mail_active" value="0" <?php echo !$info[\'mail_active\']?\'checked="checked"\':\'\'; ?> />Disable</label>'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_active\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Host</td>'."\n".'<td><input type="text" name="mail_host" size=35 value="<?php echo $info[\'mail_host\']; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_host\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Port</td>'."\n".'<td><input type="text" name="mail_port" size=6 value="<?php echo $info[\'mail_port\']?$info[\'mail_port\']:\'\'; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_port\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Protocol</td>'."\n".'<td>'."\n".'<select name="mail_protocol">'."\n".'<option value=\'POP\'>&mdash; Select Mail Protocol &mdash;</option>'."\n".'<option value=\'POP\' <?php echo ($info[\'mail_protocol\']==\'POP\')?\'selected="selected"\':\'\'; ?>>POP</option>'."\n".'<option value=\'IMAP\' <?php echo ($info[\'mail_protocol\']==\'IMAP\')?\'selected="selected"\':\'\'; ?>>IMAP</option>'."\n".'</select>'."\n".'<font class="error">&nbsp;<?php echo $errors[\'mail_protocol\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Encryption</td>'."\n".'<td>'."\n".'<select name="mail_encryption">'."\n".'<option value=\'NONE\'>None</option>'."\n".'<option value=\'SSL\' <?php echo ($info[\'mail_encryption\']==\'SSL\')?\'selected="selected"\':\'\'; ?>>SSL</option>'."\n".'</select>'."\n".'<font class="error">&nbsp;<?php echo $errors[\'mail_encryption\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Fetch Frequency</td>'."\n".'<td>'."\n".'<input type="text" name="mail_fetchfreq" size=4 value="<?php echo $info[\'mail_fetchfreq\']?$info[\'mail_fetchfreq\']:\'\'; ?>"> Delay intervals in minutes'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_fetchfreq\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Emails Per Fetch</td>'."\n".'<td>'."\n".'<input type="text" name="mail_fetchmax" size=4 value="<?php echo $info[\'mail_fetchmax\']?$info[\'mail_fetchmax\']:\'\'; ?>"> Maximum emails to process per fetch.'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_fetchmax\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td valign="top">Fetched Emails</td>'."\n".'<td>'."\n".'<input type="radio" name="postfetch" value="archive" <?php echo ($info[\'postfetch\']==\'archive\')? \'checked="checked"\': \'\'; ?>>'."\n".'Move to: <input type="text" name="mail_archivefolder" size="20" value="<?php echo $info[\'mail_archivefolder\']; ?>"/> folder.'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'mail_folder\']; ?></font>'."\n".'<input type="radio" name="postfetch" value="delete" <?php echo ($info[\'postfetch\']==\'delete\')? \'checked="checked"\': \'\'; ?>>'."\n".'Delete fetched emails'."\n".'<input type="radio" name="postfetch" value="" <?php echo (isset($info[\'postfetch\']) && !$info[\'postfetch\'])? \'checked="checked"\': \'\'; ?>>'."\n".'Do nothing (Not recommended)'."\n".'<br><em>Moving fetched emails to a backup folder is highly recommended.</em> &nbsp;<font class="error"><?php echo $errors[\'postfetch\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<th colspan="2">'."\n".'<em><strong>SMTP Settings</strong>: When enabled the <b>email account</b> will use SMTP server instead of internal PHP mail() function for outgoing emails. &nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp\']; ?></font></em>'."\n".'</th>'."\n".'</tr>'."\n".'<tr><td>Status</td>'."\n".'<td>'."\n".'<label><input type="radio" name="smtp_active" value="1" <?php echo $info[\'smtp_active\']?\'checked\':\'\'; ?> />Enable</label>'."\n".'<label><input type="radio" name="smtp_active" value="0" <?php echo !$info[\'smtp_active\']?\'checked\':\'\'; ?> />Disable</label>'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp_active\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>SMTP User</td>'."\n".'<td><input type="text" name="smtp_user" size=35 value="<?php echo $info[\'smtp_user\']; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp_host\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>SMTP Password</td>'."\n".'<td><input type="text" name="smtp_pass" size=35 value="<?php echo $info[\'smtp_pass\']; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp_host\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>SMTP Host</td>'."\n".'<td><input type="text" name="smtp_host" size=35 value="<?php echo $info[\'smtp_host\']; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp_host\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>SMTP Port</td>'."\n".'<td><input type="text" name="smtp_port" size=6 value="<?php echo $info[\'smtp_port\']?$info[\'smtp_port\']:\'\'; ?>">'."\n".'&nbsp;<font class="error">&nbsp;<?php echo $errors[\'smtp_port\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr><td>Authentication Required?</td>'."\n".'<td>'."\n".'<label><input type="radio" name="smtp_auth" value="1" <?php echo $info[\'smtp_auth\']?\'checked\':\'\'; ?> />Yes</label>'."\n".'<label><input type="radio" name="smtp_auth" value="0" <?php echo !$info[\'smtp_auth\']?\'checked\':\'\'; ?> />NO</label>'."\n".'<font class="error">&nbsp;<?php echo $errors[\'smtp_auth\']; ?></font>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<td>Allow Header Spoofing?</td>'."\n".'<td>'."\n".'<input type="checkbox" name="smtp_spoofing" value="1" <?php echo $info[\'smtp_spoofing\'] ?\'checked="checked"\':\'\'; ?>>'."\n".'Allow email header spoofing <em>(only applies to emails being sent through this account)</em>'."\n".'</td>'."\n".'</tr>'."\n".'<tr>'."\n".'<th colspan="2">'."\n".'<em><strong>Internal Notes</strong>: Admin\'s notes. &nbsp;<span class="error">&nbsp;<?php echo $errors[\'notes\']; ?></span></em>'."\n".'</th>'."\n".'</tr>'."\n".'<tr>'."\n".'<td colspan=2>'."\n".'<textarea name="notes" cols="21" rows="5" style="width:60%"><?php echo $info[\'notes\']; ?></textarea>'."\n".'</td>'."\n".'</tr>'."\n".'</tbody>'."\n".'</table>'."\n".'<p style="padding-left:225px">'."\n".'<input type="submit" name="submit" value="<?php echo $submit_text; ?>">'."\n".'<input type="reset" name="reset" value="Reset">'."\n".'<input type="button" name="cancel" value="Cancel" onclick=\'window.location.href="emails.php"\'>'."\n".'</p>'."\n".'</form>';

?>
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Install osTicket SMTP Mod</title>
        <link rel="stylesheet" href="//netdna.bootstrapcdn.com/bootstrap/3.0.2/css/bootstrap.min.css">
    </head>
    <body style="background-color: #DADADA;">
        <div class="container" style="width: 750px; margin: 30px auto; border-radius: 10px; background-color: #FFFFFF; padding: 10px;">
            <h2>Install osTicket SMTP Mod <?php echo $_SERVER['SERVER_NAME']; ?></h2>
            <hr />
            <?php
            $p = filter_input(INPUT_GET,'p');
            if ($p == '') {
                if (file_exists(FILE_CONFIG)) {
                    $constants = get_constants(file_get_contents(FILE_MAIN_INC));
                    ?>
                    <div class="alert <?=($constants['THIS_VERSION'] == 'v1.7.3') ? 'alert-success' : 'alert-warning'?>">
                        <strong>Version</strong>
                        This mod is written for osTicket version v1.7.3, you have version <?=$constants['THIS_VERSION']?>
                    </div>
                    <div class="alert alert-success">
                        Do you really want to install the SMTP mod? (Only do this on clean installations!)
                    </div>
                    <div class="alert alert-danger">
                        And do you understand that the button below can break EVERYTHING???
                    </div>
                    <a href="<?=INDEX_FILE?>?p=install" class="btn btn-primary">Yes, I understand and want to install</a>
                    <?php
                }
                else {
                    ?>
                    <div class="alert alert-danger">
                        <strong>ERROR!!!</strong>
                        osTicket config file not found!
                    </div>
                    <?php
                }
            }
            elseif ($p == 'install') {
                $main_inc = get_constants(file_get_contents(FILE_MAIN_INC));
                $config = get_constants(file_get_contents(FILE_CONFIG));
                $EMAIL_TABLE = str_replace('TABLE_PREFIX.',$config['TABLE_PREFIX'],$main_inc['EMAIL_TABLE']);
                
                $error = '';
                
                $_MDB = new MYSQL_DB($config['DBHOST'],$config['DBUSER'],$config['DBNAME'],$config['DBPASS']);
                $_MDB->QUERY("SELECT * FROM `".$EMAIL_TABLE."`");
                $row = $_MDB->FETCH_ROW();
                
                $smtp_user_exists = false;
                $smtp_pass_exists = false;
                
                foreach ($row as $key=>$val) {
                    if ($key == 'smtp_user') {
                        $smtp_user_exists = true;
                    }
                    if ($key == 'smtp_pass') {
                        $smtp_pass_exists = true;
                    }
                }
                if (!$smtp_user_exists) {
                    $_MDB->QUERY("ALTER TABLE `ost_email` ADD `smtp_user` VARCHAR(255) NOT NULL AFTER `mail_lastfetch`");
                    ?>
                    <div class="alert alert-success">
                        <strong>Nice</strong>
                        MySQL Column smtp_user created
                    </div>
                    <?php
                }
                else {
                    ?>
                    <div class="alert alert-warning">
                        <strong>WARNING</strong>
                        MySQL Column smtp_user already exists
                    </div>
                    <?php
                }
                if (!$smtp_pass_exists) {
                    $_MDB->QUERY("ALTER TABLE `ost_email` ADD `smtp_pass` VARCHAR(255) NOT NULL AFTER `smtp_user`");
                    ?>
                    <div class="alert alert-success">
                        <strong>Nice</strong>
                        MySQL Column smtp_pass created
                    </div>
                    <?php
                }
                else {
                    ?>
                    <div class="alert alert-warning">
                        <strong>WARNING</strong>
                        MySQL Column smtp_pass already exists
                    </div>
                    <?php
                }
                ///////////////////////////////////////////////////////////////////////////////////////////
                if (file_exists(FILE_CLASS_EMAIL)) {
                    if (!unlink(FILE_CLASS_EMAIL)) {
                        $error = 'Cannot delete '.FILE_CLASS_EMAIL;
                    }
                }
                try {
                    $fp = fopen(FILE_CLASS_EMAIL,'w');
                    fwrite($fp,$class_email_php);
                    fclose($fp);
                    ?>
                    <div class="alert alert-success">
                        <strong>Nice</strong>
                        <?=FILE_CLASS_EMAIL?> Created
                    </div>
                    <?php
                } catch (Exception $ex) {
                    $error = 'Could not write '.FILE_CLASS_EMAIL;
                    print_r($ex);
                }
                ///////////////////////////////////////////////////////////////////////////////////////////
                if (file_exists(FILE_CLASS_MAILER)) {
                    if (!unlink(FILE_CLASS_MAILER)) {
                        $error = 'Cannot delete '.FILE_CLASS_MAILER;
                    }
                }
                try {
                    $fp = fopen(FILE_CLASS_MAILER,'w');
                    fwrite($fp,$class_mailer_php);
                    fclose($fp);
                    ?>
                    <div class="alert alert-success">
                        <strong>Nice</strong>
                        <?=FILE_CLASS_MAILER?> Created
                    </div>
                    <?php
                } catch (Exception $ex) {
                    $error = 'Could not write '.FILE_CLASS_MAILER;
                    print_r($ex);
                }
                ///////////////////////////////////////////////////////////////////////////////////////////
                if (file_exists(FILE_EMAIL_INC)) {
                    if (!unlink(FILE_EMAIL_INC)) {
                        $error = 'Cannot delete '.FILE_EMAIL_INC;
                    }
                }
                try {
                    $fp = fopen(FILE_EMAIL_INC,'w');
                    fwrite($fp,$email_inc_php);
                    fclose($fp);
                    ?>
                    <div class="alert alert-success">
                        <strong>Nice</strong>
                        <?=FILE_EMAIL_INC?> Created
                    </div>
                    <?php
                } catch (Exception $ex) {
                    $error = 'Could not write '.FILE_EMAIL_INC;
                    print_r($ex);
                }
                ///////////////////////////////////////////////////////////////////////////////////////////
                if ($error !== '') {
                    ?>
                    <div class="alert alert-danger">
                        <strong>ERROR!!!</strong>
                        <?=$error?>
                    </div>
                    <?php
                }
            }
            else {
                ?>
                <div class="alert alert-danger">
                    <strong>ERROR!!!</strong>
                    Function not available
                </div>
                <?php
            }
            ?>
            <br /><br /><br />
        </div>
    </body>
</html>
<?php
function get_constants($str) {
    $defines = array();
    $state = 0;
    $key = '';
    $value = '';
    
    $tokens = token_get_all($str);
    $token = reset($tokens);
    while ($token) {
        if (is_array($token)) {
            if ($token[0] == T_WHITESPACE || $token[0] == T_COMMENT || $token[0] == T_DOC_COMMENT) {
                // do nothing
            } else if ($token[0] == T_STRING && strtolower($token[1]) == 'define') {
                $state = 1;
            } else if ($state == 2 && is_constant($token[0])) {
                $key = $token[1];
                $state = 3;
            } else if ($state == 4 && is_constant($token[0])) {
                $value = '';
                while (is_array($token) || $token == '.') {
                    $value .= strip((is_array($token)) ? $token[1] : '.');
                    $token = next($tokens);
                }
                $token = prev($tokens);
                $state = 5;
            }
        } else {
            $symbol = trim($token);
            if ($symbol == '(' && $state == 1) {
                $state = 2;
            } else if ($symbol == ',' && $state == 3) {
                $state = 4;
            } else if ($symbol == ')' && $state == 5) {
                $defines[strip($key)] = strip($value);
                $state = 0;
            }
        }
        $token = next($tokens);
        
    }
    return ($defines);
}
function is_constant($token) {
    return $token == T_CONSTANT_ENCAPSED_STRING || $token == T_STRING ||
        $token == T_LNUMBER || $token == T_DNUMBER;
}
function strip($value) {
    return preg_replace('!^([\'"])(.*)\1$!', '$2', $value);
}


class MYSQL_DB{private $DB_HOST;private $DB_USER;private $DB_DBASE;private $DB_PASS;private $DB_PREFIX;private $DB_RESULT;private $DB_CURRENT_QUERY;private $MYSQLI;private $DB_TM;private $DB_DEBUG;public function __construct($DB_HOST,$DB_USER,$DB_DBASE,$DB_PASS,$DB_PREFIX=''){$this->DB_HOST=$DB_HOST;$this->DB_USER=$DB_USER;$this->DB_DBASE=$DB_DBASE;$this->DB_PASS=$DB_PASS;$this->DB_PREFIX=$DB_PREFIX;$this->DB_CURRENT_QUERY=0;$this->DB_RESULT=array();$this->DB_TM=array();$this->DB_DEBUG=array();$this->DB_CONNECT();}public function __destruct(){$this->DB_DISCONNECT();}public function DB_CONNECT(){$this->MYSQLI=new mysqli($this->DB_HOST,$this->DB_USER,$this->DB_PASS,$this->DB_DBASE);if($this->MYSQLI->connect_errno){print $this->MYSQLI->connect_error;}}public function DB_DISCONNECT(){$this->MYSQLI->close();}public function NUM_ROWS($NUM=0){$NUM=($NUM==0)?$this->DB_CURRENT_QUERY:$NUM;return $this->DB_RESULT[$NUM]->num_rows;}public function LAST_ID(){return $this->MYSQLI->insert_id;}public function QUERY($QUERY){$QUERY=str_replace('{P}',$this->DB_PREFIX,$QUERY);$start=$this->getmicrotime();$this->DB_CURRENT_QUERY++;if(empty($this->DB_RESULT[$this->DB_CURRENT_QUERY])){$this->DB_RESULT[$this->DB_CURRENT_QUERY]=0;}if(is_resource($this->DB_RESULT[$this->DB_CURRENT_QUERY])){$this->DB_RESULT[$this->DB_CURRENT_QUERY]->free_result();}$this->DB_RESULT[$this->DB_CURRENT_QUERY]=$this->MYSQLI->query($QUERY)or print($this->MYSQLI->error);$this->DB_TM[$this->DB_CURRENT_QUERY]=$this->getmicrotime()- $start;return $this->DB_CURRENT_QUERY;}public function QUERY_INSERT($TABLE,$DATA){if(is_array($DATA)){$q='INSERT INTO `';$q.=($this->DB_PREFIX==='')?'':$this->DB_PREFIX.'_';$q.=$TABLE.'` (';$q2='VALUES (';foreach($DATA as $key=>$val){$q.='`'.$this->ESCAPE_STRING($key).'`,';$q2.='\''.$this->ESCAPE_STRING($val).'\',';}$q2=substr($q2,0,strlen($q2)-1).')';$q=substr($q,0,strlen($q)-1).') '.$q2;return $this->QUERY($q);}else{$this->DEBUG_ERROR('QUERY_INSERT',0,'The function QUERY INSERT expects an array.');}}public function QUERY_UPDATE($TABLE,$DATA,$IDENT){if(is_array($DATA)){if(is_array($IDENT)){$q='UPDATE `';$q.=($this->DB_PREFIX==='')?'':$this->DB_PREFIX.'_';$q.=$TABLE.'` SET ';foreach($DATA as $key=>$val){$q.='`'.$this->ESCAPE_STRING($key).'` = \''.$this->ESCAPE_STRING($val).'\',';}$q=substr($q,0,strlen($q)-1).' ';$q.='WHERE ';foreach($IDENT as $key=>$val){$q.='`'.$this->ESCAPE_STRING($key).'` = \''.$this->ESCAPE_STRING($val).'\' AND ';}$q=substr($q,0,strlen($q)-4);return $this->QUERY($q);}else{$this->DEBUG_ERROR('QUERY_UPDATE',0,'The function QUERY_UPDATE expects an array [$IDENT].');}}else{$this->DEBUG_ERROR('QUERY_UPDATE',0,'The function QUERY_UPDATE expects an array [$DATA].');}}public function FETCH_ROW($NUM=0){$NUM=($NUM==0)?$this->DB_CURRENT_QUERY:$NUM;return($this->DB_RESULT[$NUM]->fetch_assoc());}public function ESCAPE_STRING($STR){return($this->MYSQLI->real_escape_string($STR));}public function GET_LOGGING(){return '<code><b><u>'.$this->DB_CURRENT_QUERY.'</u></b> queries have been processed, in <b><u>'.array_sum($this->DB_TM).' seconds</u></b>.</code>';}public function getmicrotime(){list($usec,$sec)=explode(" ",microtime());return((float)$usec +(float)$sec);}}